<template>
  <div v-loading="isloading" class="w-full h-full p-6">
    <div>
      <ul class="list-disc">
        <div class="py-4 pr-2 mb-1 rounded-lg pl-7 bg-background2">
          <li>
            {{
              $t(
                "system_will_diplay_the_deposit_amount_with_decimal_that_you_need_to_transfer_you_have_to_transfer_the_exact_amount_as_display"
              )
            }}
          </li>
        </div>
        <div class="py-4 pr-2 mb-3 rounded-lg pl-7 bg-background2">
          <li>
            {{
              $t(
                "system_will_check_the_transaction_and_automatically_recharge_your_account_within_1_5_minutes_after_you_deposit"
              )
            }}
          </li>
        </div>
      </ul>
    </div>
    <div v-if="beforeSubmit">
      <div class="flex flex-col w-full">
        <el-form
          ref="ruleFormRef"
          :model="requestModel"
          :rules="formRule"
          label-width="200px"
          label-position="left"
        >
          <span class="text-[16px] mb-2 fc-hint">{{ $t("from") }}</span>
          <el-form-item :label="$t('bank')" prop="PlayerBankName">
            <el-select
              v-model="requestModel.PlayerBankName"
              class="w-full"
              default-first-option
              :placeholder="$t('select')"
            >
              <el-option
                v-for="(bank, index) in playerBankDeposit"
                :key="index"
                :label="bank.BankName"
                :value="bank.Id"
              />
            </el-select>
          </el-form-item>
          <el-form-item
            :label="$t('bank_account_name')"
            prop="PlayerBankAccountName"
          >
            <el-input
              v-model="requestModel.PlayerBankAccountName"
              id="depositBankAccountName"
              :disabled="!isFirstTimeDeposit"
            />
          </el-form-item>
          <el-form-item
            :label="$t('bank_account_number')"
            prop="PlayerBankAccountNumber"
          >
            <el-input
              v-model="requestModel.PlayerBankAccountNumber"
              id="depositBankAccountNumber"
              :disabled="!isFirstTimeDeposit"
            />
          </el-form-item>
          <el-form-item :label="$t('amount')" prop="Amount">
            <el-input
              v-model="requestModel.Amount"
              id="depositAmount"
              @input="onInputValue($event, requestModel, 'Amount')"
              :placeholder="amountPlaceholder"
            >
              <template v-if="isNeedToMultiplyByThousand" #append>000</template>
            </el-input>
            <span
              v-if="isNeedToMultiplyByThousand"
              class="order-1 text-xs fc-hint mt-3"
              >{{
                $t(
                  `deposit_amount_shown_by_the_system_${profile.Currency.toLowerCase()}`
                )
              }}</span
            >
          </el-form-item>
          <span class="text-[16px] mb-2 fc-hint">{{ $t("to") }}</span>
          <el-form-item :label="$t('bank')" prop="PlayerBankName">
            <el-select
              v-model="requestModel.CompanyBankId"
              class="w-full"
              id="depositCompanyBank"
              default-first-option
              :placeholder="$t('select')"
            >
              <el-option
                v-for="(bank, index) in autoDepositBank"
                :key="index"
                :label="bank.BankName"
                :value="bank.Id"
              />
            </el-select>
          </el-form-item>
          <div class="flex items-center justify-center">
            <el-button
              type="primary"
              round
              :loading="isloading"
              @click="onSubmitDeposit(ruleFormRef)"
              >{{ $t("submit") }}</el-button
            >
          </div>
        </el-form>
      </div>
    </div>
    <div v-else v-loading="isloading">
      <div class="w-full mb-3">
        <span class="text-[16px] mb-2 fc-hint">{{
          $t("selected_deposit_bank_account")
        }}</span>
        <el-form
          class="customize-form text-[14px]"
          label-width="250px"
          label-position="left"
        >
          <el-form-item :label="$t('bank_name')">
            <span>{{ bankName }}</span>
          </el-form-item>
          <el-form-item :label="$t('bank_account_name')">
            <span>{{ bankAccountName }}</span>
          </el-form-item>
          <el-form-item :label="$t('bank_account_number')">
            <el-button
              type="primary"
              size="small"
              plain
              round
              @click="copyAccountNumber"
              >{{ $t("copy") }}</el-button
            >
          </el-form-item>
        </el-form>
      </div>
      <div class="flex items-center w-full p-3 rounded-lg display-box">
        <div
          class="w-full flex flex-col items-center border-r-[1px] border-color-config"
        >
          <span class="font-semibold text-[14px] mb-3">{{ $t("amount") }}</span>

          <div class="flex items-start font-bold">
            <span class="mt-1 mr-1">{{ currency }}</span>
            <span class="text-xl">{{ balance }}</span>
          </div>
          <span class="my-2">{{
            $t("click_to_copy_this_exact_amount_below")
          }}</span>
          <el-button
            type="primary"
            size="small"
            plain
            round
            @click="copyExactBalance"
            >{{ $t("copy") }}</el-button
          >
        </div>
        <div class="flex flex-col items-center w-full">
          <span class="font-semibold mb-3 text-[14px]">{{
            $t("remaining_time")
          }}</span>
          <span class="text-xl font-bold">{{ remainingTimeForDisplay }}</span>
        </div>
      </div>
      <div class="flex flex-col items-center w-full gap-4 mt-3">
        <div class="fc-hint">
          {{ $t("please_transfer_the_exact_amount_as_displayed") }}
        </div>
        <div class="flex gap-1">
          <el-button type="primary" round @click="copyAccountNumber">{{
            $t("copy_account_number")
          }}</el-button>
          <el-button
            type="danger"
            :loading="isloading"
            plain
            round
            @click="cancelTransaction"
            >{{ $t("cancel") }}</el-button
          >
        </div>
      </div>
    </div>
  </div>
</template>
<script lang="ts">
import { defineComponent, PropType, toRefs } from "vue";
import { ProfileDto } from "@/models/getProfileResponse";
import useAutoDeposit from "@/composables/payment/deposit/useAutoDeposit";
import { IGetTransactionBankListResponse } from "@/models/getTransactionBankListResponse";

export default defineComponent({
  props: {
    normalBanks: {
      type: Object as PropType<IGetTransactionBankListResponse>,
      required: true,
      default: {} as IGetTransactionBankListResponse,
    },
    profile: {
      type: Object as PropType<ProfileDto>,
      required: true,
    },
  },
  setup(props) {
    const { normalBanks, profile } = toRefs(props);
    const {
      bankName,
      bankAccountName,
      currency,
      balance,
      remainingTimeForDisplay,
      copyAccountNumber,
      copyExactBalance,
      beforeSubmit,
      autoDepositBank,
      requestModel,
      isNeedToMultiplyByThousand,
      formRule,
      ruleFormRef,
      onSubmitDeposit,
      amountPlaceholder,
      cancelTransaction,
      playerBankDeposit,
      isloading,
      isFirstTimeDeposit,
    } = useAutoDeposit(normalBanks, profile);
    const { onInputValue } = commonHelper;
    return {
      bankName,
      bankAccountName,
      cancelTransaction,
      currency,
      balance,
      remainingTimeForDisplay,
      copyAccountNumber,
      copyExactBalance,
      beforeSubmit,
      autoDepositBank,
      isNeedToMultiplyByThousand,
      requestModel,
      formRule,
      onSubmitDeposit,
      ruleFormRef,
      isloading,
      amountPlaceholder,
      playerBankDeposit,
      isFirstTimeDeposit,
      onInputValue,
    };
  },
});
</script>
<style lang="scss">
.customize-form {
  .el-form-item {
    margin-bottom: 0px;
  }
}
.display-box {
  border: 1px solid var(--border);
}
.border-color-config {
  border-color: var(--border);
}
.el-select {
  width: 100%;
}
</style>
